//+------------------------------------------------------------------+
//|                                                       Cursor.mqh |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "220Volt"


 //   , ,  .
#define cursor.PRICE_BAR_WIDTH 40

#import "user32.dll"
   int GetCursorPos(int point[]);
   int GetWindowRect(int hWnd,int rect[]);
   int GetSystemMetrics(int nIndex);


//+------------------------------------------------------------------+
//| public                                                           |
//+------------------------------------------------------------------+

 //      , -1  .
int cursor.bar_position()
{
   int point[2];
   int rect[4];
   int handle = WindowHandle(Symbol(), Period()); 
   if(handle == 0)
      return(-1);
   if( ! GetCursorPos(point) )
      return(-1);
   if( ! GetWindowRect(handle, rect) )
      return(-1);
   if(point[0] < rect[0]   ||  
      point[0] >= rect[2]  ||  
      point[1] < rect[1]   ||  
      point[1] >= rect[3])
      return(-1);
      
   double x_shift = (point[0] - rect[0] * 1.0) / (rect[2] - rect[0] - 1 - cursor.PRICE_BAR_WIDTH);
   int res = WindowFirstVisibleBar() - WindowBarsPerChart() * x_shift;
   if(res < 0)
      return(-1);
   return(res);  
}

 //      , -1  .      :
 //                  ---------------------------------------------
 //                  |              |              |             |
 //                  |       0      |       1      |      2      |
 //                  |              |              |             |
 //                  |--------------|--------------|-------------|
 //                  |              |              |             |
 //                  |       3      |       4      |      5      |
 //                  |              |              |             |
 //                  |              |              |             |
 //                  |--------------|--------------|-------------|
 //                  |              |              |             |
 //                  |       6      |       7      |      8      |
 //                  |              |              |             |
 //                  |              |              |             |
 //                  ---------------------------------------------
int cursor.sector_position()
{
   double screen_width = GetSystemMetrics(0);
   double screen_hight = GetSystemMetrics(1);
   if(screen_width == 0  ||  screen_hight == 0)
      return(-1);
   
   int point[2];
   if( ! GetCursorPos(point) )
      return(-1);
   
   int res = 0;
   
   if( point[1] / screen_hight > 0.666 )
      res += 6;
   else
      if( point[1] / screen_hight > 0.333 )
         res += 3;
   
   if( point[0] / screen_width > 0.666 )
      res += 2;
   else
      if( point[0] / screen_width > 0.333 )
         res += 1;
   
   return(res);
}