//+------------------------------------------------------------------+
//|                                                    Point_gen.mqh |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "220Volt"


//+------------------------------------------------------------------+
//| private                                                          |
//+------------------------------------------------------------------+
int point_gen.timeframe;
int point_gen.pos_bar;
int point_gen.pos_point;
int point_gen.count;

//+------------------------------------------------------------------+
//| public                                                           |
//+------------------------------------------------------------------+

 // enum Position_selection
//{
      #define point_gen.HIGH     0
      #define point_gen.LOW      1
      #define point_gen.WHOLE    2
//};

 //  .
void point_gen.init(int first_bar,
                    int first_point,
                    int last_bar,
                    int last_point,
                    int timeframe)
{
   point_gen.timeframe = timeframe;
   point_gen.pos_bar = first_bar;
   point_gen.pos_point = 0;
   point_gen.count = (first_bar - last_bar + 1) * 2;
   
   double open;
   double close;
   if(first_point != point_gen.WHOLE)
   {
      open = iOpen(NULL, timeframe, first_bar);
      close = iClose(NULL, timeframe, first_bar);
      if(open == 0  ||  close == 0)
      {
         point_gen.count = 0;
         return;
      }
   
      if(open < close)
      {
         if(first_point == point_gen.HIGH)
         {
            point_gen.count --;
            point_gen.pos_point = 1;
         }
      }
      else
      {
         if(first_point == point_gen.LOW)
         {
            point_gen.count --;
            point_gen.pos_point = 1;
         }
      } 
   }
   
   if(last_point != point_gen.WHOLE)
   {
      open = iOpen(NULL, timeframe, last_bar);
      close = iClose(NULL, timeframe, last_bar);
      if(open == 0  ||  close == 0)
      {
         point_gen.count = 0;
         return;
      }
   
      if(open < close)
      {
         if(last_point == point_gen.LOW)
            point_gen.count --;
      }
      else
      {
         if(last_point == point_gen.HIGH)
            point_gen.count --;
      } 
   }
}

bool point_gen.is_full()    { return(point_gen.count > 0); }

 //  0  .
double point_gen.get()
{
   if(point_gen.count < 1)
      return(0);
   
   double open = iOpen(NULL, point_gen.timeframe, point_gen.pos_bar);
   double close = iClose(NULL, point_gen.timeframe, point_gen.pos_bar);
   double high = iHigh(NULL, point_gen.timeframe, point_gen.pos_bar);
   double low = iLow(NULL, point_gen.timeframe, point_gen.pos_bar);
   if(open == 0  ||  close == 0  ||  high == 0  ||  low == 0)
      return(0);
      
   double ret;   
   if(point_gen.pos_point == 0)
   {
      if(open < close)
         ret = low;
      else
         ret = high;
      point_gen.pos_point = 1;
   }
   else
   {
      if(open < close)
         ret = high;
      else
         ret = low;
      point_gen.pos_point = 0;
      point_gen.pos_bar --;
   }
   point_gen.count --;
   return(ret);
}

int point_gen.last_bar_index()
{
   if(point_gen.pos_point == 1)
      return(point_gen.pos_bar);
   else
      return(point_gen.pos_bar + 1);
}